#include <pthread.h>
#include <sys/select.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <signal.h>


#define min(a, b) ((a < b) ? a : b)
#define std 0
#define MAX_BURST 200000 //tamaño del balde por default
#define INITIAL_LEAKY_RATE 10000 //velocidad en Bytes/s por default

//Funcion que se ejecuta al llegar la señal
static void sig_c1p2(int signo);

// descriptores de entrada y salida
int entrada,salida;

//Flag para cerrar la ejecucion del programa
int boolRun = 1;
int boolReconf = 0;
int boolPause = 1;

void * otraDireccion(void * arg){
  do{
    if(boolPause == 1){
      pause();
      printf("Reconfigurando proceso...!!\n");
      send(entrada,"Reconfigurando proceso...!!\n",28,0);
      FILE *test;
      if((test = fopen("/root/test.txt","r")) == 0){
        printf("No se pudo abrir el fichero de configuracion.\n");  
        exit(-1);
      }
      fclose(test);
      boolReconf = 0;
    }
  }while(boolRun);
  printf("Hebra cerrada.\n");
}

void * demo(void * arg){
  int i = 0,j = 0;
  char msg[]="a1";
  do{
    if(boolPause == 1){
      sleep(2);
      send(entrada,msg,2,0);
      printf("%s:%d:%d:%d:%d\n",msg,i,j,msg[0],msg[1]);
      msg[0] = 97 + (i++)%4;
      if((i)%4 == 0){
        msg[1] = 48 + (j++)%2;
      }
    }
  }while(boolRun);
  printf("Hebra cerrada.\n");
}

int main(int argc, char * argv[])
{
  char buf[100];
  char hostname[64];
  int PORTNUMBER;
  //int PUERTOREMOTO=;   
  int s, n, len,err,ind;
  pthread_t tid1,tid2,tid3,tid4,tid5;
  struct sockaddr_in strucPropio;
  struct sockaddr_in strucRemoto;
  struct hostent *hp;
  fd_set readfds;
  struct timeval time;
  time.tv_sec=0;
  time.tv_usec=0;
  unsigned int idSensor,valueSensor,valor1,valor2;
  FILE *out;

  if((out = fopen("salida.txt","w")) == 0){
    printf("No se pudo abrir el fichero de salida.\n");  
    exit(-1);
  }

  if(argc!=2)  {
      printf("Error de sistaxis: %s <puerto>\n",argv[0]);  
      exit(-1);
  }
    PORTNUMBER=atoi(argv[1]);

  if (signal(SIGUSR1, sig_c1p2) == SIG_ERR)
    printf("No se puede capturar SIGUSR1"); //SIGINT
  if (signal(SIGINT, sig_c1p2) == SIG_ERR)
    printf("No se puede capturar SIGINT"); //SIGINT
  if (signal(SIGUSR2, sig_c1p2) == SIG_ERR)
    printf("No se puede capturar SIGUSR2"); //SIGINT

  /* Crea el socket */
  s = socket(AF_INET, SOCK_STREAM, 0);

  /* Create the address of the server. */
  strucPropio.sin_family = AF_INET;
  strucPropio.sin_port = htons(PORTNUMBER);
  strucPropio.sin_addr.s_addr = htonl(INADDR_ANY); /* Use the wildcard address.*/
  len = sizeof(struct sockaddr_in);

  /* Bind the socket to the address. */
  if( bind(s, (struct sockaddr *) &strucPropio, len))
    printf("bind error");

  /* Listen for connections.  */
  listen(s, 5);

  /* Accept a connection.  */
  entrada = accept(s, (struct sockaddr *) &strucRemoto, &len);

  /* Read from the socket until end-of-file and
    * print what we get on the standard output.  */
  printf("Connection from : %s\n",inet_ntoa(strucRemoto.sin_addr)); //duda para borrarlo
  
//   ////////////////////////////////////SALIDA/////////////////////////////////////////
//   /* Look up our host's network address.*/
//   hp = gethostbyname(hostname);
//   /* Create a socket in the INET domain.*/
//   entrada = socket(AF_INET, SOCK_STREAM, 0);
//   /* Create the address of the server. */
//   strucRemoto.sin_family = AF_INET;
//   strucRemoto.sin_port = htons(PORTNUMBER);
//   strucRemoto.sin_addr.s_addr = inet_addr ("192.168.1.2");
//   len = sizeof(struct sockaddr_in);
//   /* Connect to the server. */
//   connect(entrada, (struct sockaddr *) &strucRemoto, len);
//   ///////////////////////////////////////////////////////////////////////////////////
//   
//   //   /* Bind the socket to the address. */
//   if( bind(s, (struct sockaddr *) &strucRemoto, len))
//     printf("bind error");
//   
//   //   /* Listen for connections.  */
//   listen(s, 5);
// // 
// //   /* Accept a connection.  */
//   entrada = accept(s, (struct sockaddr *) &strucRemoto, &len);

  // crea hilo otraDireccion
  err = pthread_create(&tid1, NULL,demo, NULL);
  if (err != 0){
    printf("No se puede crear una de las Hebras \n");
    exit(0);
  }

  while(boolRun){
    if(boolPause == 1){
      n=recv(entrada,buf,2,0);
      if((buf[1] != 10) && (buf[0] != 10)&&(buf[1] != 0) && (buf[0] != 0)){
        idSensor= (buf[1]>>4)&0x0f;
        valueSensor = (buf[1]<<8)&0x0f00 | buf[0]&0x0ff;
        printf("%d:%d\n",idSensor,valueSensor);
        //fwrite ("Lalalala\n" , sizeof(char), 9 , out );
        fprintf(out,"%d:%d\n",idSensor,valueSensor); 
        fflush(out);
      }
    }
  }
  printf("Saliendo del Main.\n");

  // Espera a la hebra de OtraDireccion
  pthread_join(tid1,NULL);

  close(entrada);
  close(salida);
  fclose(out);
  close(s);
  exit(0);

}


//Funcion que se ejecuta al llegar la señal
static void sig_c1p2(int signo)
{
  if (signo == SIGINT){  //Si es ^C
    printf("Saliendo del proyecto\n");
    boolRun = 0;
  }else if (signo == SIGUSR1){  //Si es ^C
    boolReconf = 1;
  }else if (signo == SIGUSR2){  //Si es ^C
    if(boolPause == 1)
      boolPause = 0;
    else 
      boolPause = 1;
  }
  return;
}



/*
#include <time.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <sys/types.h>
#include "include/uci.h"

#define SIZE 256

int main (void)
{
  printf("(!Lograndolo)\n");
  
//   char section[]="generales2";
//   char option[]="valvula9";
//   char value[]="1234567890";
  
  struct uci_context *ctx;
  ctx = uci_alloc_context();
  struct uci_ptr ptr;
  
  struct uci_package **package;
  
  FILE *stream;
  char buffer[10];
  int lSize = 9;
  stream = fopen("/etc/config/test","r");
  fread (buffer,1,lSize,stream);
  buffer[9] = 0x00;
  printf("(!Lograndolo)\n");
  printf("STREAM: %s\n",buffer);
  bool single = true;
  
  uci_load(ctx, "test",package);
  
//   ptr.package = package;
//   ptr.option = option;
//   ptr.value = value;

  //printf("PKG: %s, OPT: %s, VAL: %s\n","lala",ptr.option,ptr.value);
  
  //uci_set(ctx,&ptr);
 kill -SIGUSR1 `ps aux |grep Proyecto-PDS | awk '{print $1}'`


  return 0;
}
*/

